.plugin zshell

;#include "TI-85.h" ; for ZShell 4.0 and Rigel
#include "USGARD.h" ; for Usgard
#define TI85

.dw ShellTitle

ContinuePrg:
 ROM_CALL(BUSY_OFF)
 set 1,(iy+13)
 ROM_CALL(CLEARTEXT)
 ld de,TitlePic
 CALL_(FixGet)
 CALL_(SetUp)
 
ContProg:
 CALL_(Black_Band)
 CALL_(InvText)
 CALL_(GetStars)
 ld bc,$0002
 CALL_(ShowBig)
 ld de,text
 CALL_(FixGet)
 inc c
 CALL_(ShowBig)
 CALL_(GetStars)
 inc c
 CALL_(ShowBig)
 ld de,Menu
 CALL_(FixGet)
 ld bc,$3A01
 CALL_(ShowSmall)
 ld c,$18
 CALL_(ShowSmall)
 ld c,$39
 CALL_(ShowSmall)
 ld c,$54
 CALL_(ShowSmall)
 ld c,$70
 CALL_(ShowSmall)
 CALL_(InvText)

MainKeyLoop:
 call GET_KEY
 cp $37
 JUMP_Z(EXIT_)
 cp $0A
 CALL_Z(c_up)
 cp $0B
 CALL_Z(c_down)
 cp $34
 jr z,Credits
 cp $33
 jr z,Help
 cp $31
 JUMP_Z(EXIT_)
 cp $35
 JUMP_Z(StartGame)
 cp $32
 JUMP_Z(About)
 JUMP_(MainKeyLoop)
 
Credits:
 ROM_CALL(CLEARTEXT)
 ld de,people
 CALL_(FixGet)
 CALL_(InvText)
 xor b
 xor c
 CALL_(ShowBig)
 ld c,$04
 CALL_(ShowBig)
 CALL_(InvText)
 ld bc,$0D00
 CALL_(ShowSmall)
 ld b,$15
 CALL_(ShowSmall)
 ld b,$32
 CALL_(ShowSmall)
 CALL_(Pause)
 JUMP_(ContProg)

Help:
 ROM_CALL(CLEARTEXT)
 ld de,stuff
 CALL_(FixGet)
 CALL_(InvText)
 xor b
 xor c
 CALL_(ShowBig)
 CALL_(InvText)
 ld b,$0D
 CALL_(ShowSmall)
 ld b,$15
 CALL_(ShowSmall)
 ld b,$1D
 CALL_(ShowSmall)
 ld b,$25
 CALL_(ShowSmall)
 ld b,$2D
 CALL_(ShowSmall)
 CALL_(Pause)
 JUMP_(ContProg)

About:
 ROM_CALL(CLEARTEXT)
 ld de,IntroText
 CALL_(FixGet)
 xor b
 xor c
 CALL_(ShowSmall)
 ld b,$08
 CALL_(ShowSmall)
 ld b,$10
 CALL_(ShowSmall)
 ld b,$18
 CALL_(ShowSmall)
 CALL_(InvText)
 ld b,$28
 CALL_(ShowSmall)
 CALL_(InvText)
 CALL_(Pause)
 JUMP_(ContProg)

Pause:
 call GET_KEY
 or a
 jr z,Pause
 ret
 
Black_Band:
 ROM_CALL(CLEARTEXT)
 ld hl,$FFA0
 ld de,$FFA1
 ld (hl),$FF
 ld bc,$5F
 ldir
 ret
 
InvText:
 bit 3,(iy+5)
 jr nz,ResText
 set 3,(iy+5)
 ret
ResText:
 res 3,(iy+5)
 ret
 
c_up:
 ld a,1
 jr c_main
c_down:
 ld a,-1
c_main:
 ld hl,CONTRAST ; get the current contrast
 add a,(hl) ; add either 1 or substract 1 depending on mode
 and 31 ; make sure it's within the boundaries
 ld (hl),a ; set the RAM location
 out (2),a ; tell the display to update the contrast
 ret
 
ShowBig:
 ld (CURSOR_ROW),bc
 ROM_CALL(D_ZT_STR)
 ret
 
ShowSmall:
 ld (CURSOR_X),bc
 ROM_CALL(D_ZM_STR)
 ret
 
SetUp:
 ld de,GRAPH_MEM
 CALL_(DspRLE)
 ld hl,$FC00
 ld de,GRAPH_MEM
 
FadeIn:
 ld b,8
 xor a
 ld (Val),a
 push hl
 push de
Loop1:
 push bc
 ld b,128
Loop:
 ld a,(de)
 cp (hl)
 jr z,Fin
 ld a,1
 ld (Val),a
 inc (hl)
 ld a,(de)
 cp (hl)
 jr z,Fin
 inc (hl)
Fin:
 inc hl
 inc de
 djnz Loop
 pop bc
 djnz Loop1
 pop de
 pop hl
 ld a,(Val)
 JUMP_NZ(FadeIn)
 
 CALL_(Pause)

 ld hl,$FC00
FadeOut:
 ld b,8
 xor a
 ld ($FBFF),a
 push hl
Loop3:
 push bc
 ld b,128
Loop2:
 ld a,(hl)
 or a
 jr z,Fin2
 ld a,1
 ld ($FBFF),a
 dec (hl)
 ld a,(hl)
 or a
 jr z,Fin2
 dec (hl)
Fin2:
 inc hl
 djnz Loop2
 pop bc
 djnz Loop3
 pop hl
 ld a,($FBFF)
 jr nz,FadeOut
 ret
 
DspRLE:
 ld bc,1024
DispRLEL:
 ld a,(hl)
 cp $91
 jr z,DispRLERun
 ldi
DispRLEC:
 ld a,b
 or c
 jr nz,DispRLEL
 ret
DispRLERun:
 inc hl
 ld a,(hl)
 inc hl
 push hl
 ld h,(hl)
 ex de,hl
DispRLERunL:
 ld (hl),a
 inc hl
 dec bc
 dec d
 jr nz,DispRLERunL
 ex de,hl
 pop hl
 inc hl
 jr DispRLEC
 ret
 
GetCart:
 ld de,Cart
 jr FixGet

GetCartman:
 ld de,cartman
 jr FixGet
 
GetBuu:
 ld de,Buu
 jr FixGet

GetMajin:
 ld de,Majin
 ld bc,9
 jr FixGet
 
GetKakarot:
 ld de,Kakarot
 jr FixGet
 
GetGokuGT:
 ld de,GokuGT
 jr FixGet
 
GetChar1:
 ld de,Char1
 ld bc,10
 jr FixGet
 
GetStars:
 ld de,stars
 jr FixGet
 
GetFrieza:
 ld de,Frieza
 jr FixGet
 
GetCharF:
 ld de,CharF
 ld bc,6
 jr FixGet

GetIsFire:
 ld de,IsFire
 jr FixGet

GetIsFireG:
 ld de,IsFireG
 jr FixGet
 
GetChar2:
 ld de,Char2
 ld bc,8

FixGet:
 ld hl,($8C3C)
 add hl,de
 ret
 
GetGGtText:
 ld de,GGtText
 ld bc,13
 jr FixGet
 
GetGotenks:
 ld de,Gotenks
 jr FixGet
 
GetGotnk:
 ld de,Gotnk
 ld bc,7
 jr FixGet
 
GetVegeta:
 ld de,Vegeta
 jr FixGet
 
GetSSJ3_Goku:
 ld de,SSJ3_Goku
 jr FixGet
 
GetGohan:
 ld de,Gohan
 jr FixGet
 
GetChar5:
 ld de,Char5
 ld bc,9
 jr FixGet
 
GetFball:
 ld de,Fireball
 jr FixGet

GetFball2:
 ld de,Fireball2
 jr FixGet
 
GetTrunks:
 ld de,Trunks
 jr FixGet
 
GetChar6:
 ld de,Char6
 ld bc,10
 jr FixGet
 
GetChar4:
 ld de,Char4
 ld bc,10
 jr FixGet
 
GetRaditz:
 ld de,Raditz
 jr FixGet

GetPlay2:
 ld de,play2
 jr FixGet

GetPlay1:
 ld de,play1
 jr FixGet
 
GetRad:
 ld de,Rad
 ld bc,6
 jr FixGet
 
GetClear:
 ld de,CleanChar
 jr FixGet
 
GetP_Op2:
 ld de,P_Op2
 jr FixDE
 
GetP_Op3:
 ld de,P_Op3
FixDE:
 push hl
 CALL_(FixGet)
 ex de,hl
 pop hl
 ret
 
GetDiffMode:
 ld de,difficulty_mode
 jr FixA

GetPlay1_op2:
 ld de,play1_op
 jr FixA
 
GetPlay2_op2:
 ld de,play2_op
 jr FixA

GetVegetaxy2:
 ld de,Vegetaxy
 jr FixA

GetVegetaxy2p1:
 ld de,Vegetaxy+1
 jr FixA

GetFireGxy:
 ld de,FireGxy
 jr FixA

GetKakarotxy:
 ld de,Kakarotxy
 jr FixA

GetKakarotxyP1:
 ld de,Kakarotxy+1
 jr FixA

GetFirexy:
 ld de,Firexy
 jr FixA
 
GetFirexyP1:
 ld de,Firexy+1
 jr FixA

GetFoldxy:
 ld de,FirexyOld
 jr FixA
 
GetFoldxyP1:
 ld de,FirexyOld+1
 jr FixA

GetFGoldxy:
 ld de,FireGxyOld
 jr FixA
 
GetFGoldxyP1:
 ld de,FireGxyOld+1
 jr FixA

GetFireGxyA:
 ld de,FireGxy
 jr FixA
 
GetFireGxyP1:
 ld de,FireGxy+1
 jr FixA
 
GetKakarot_D:
 ld de,Kakarot_direction
; jr FixA
 
FixA:
 push hl
 CALL_(FixGet)
 ld a,(hl)
 pop hl
 ret
 
FixA2:
 push hl
 CALL_(FixGet)
 ld (hl),a
 pop hl
 ret

GetKakarotxy2:
 ld de,Kakarotxy
 jr FixA2

GetKakarotxy2P1:
 ld de,Kakarotxy+1
 jr FixA2
 
GetKoldxy2:
 ld de,KakarotxyOld
 jr FixA2

GetKoldxy2P1:
 ld de,KakarotxyOld+1
 jr FixA2
 
GetVoldxyP1:
 ld de,VegetaxyOld+1
 jr FixA2
 
GetVoldxy:
 ld de,VegetaxyOld
 jr FixA2
 
GetVegetaxyP1:
 ld de,Vegetaxy+1
 jr FixA2
 
GetVegetaxy:
 ld de,Vegetaxy
 jr FixA2
 
GetPlay1_op:
 ld de,play1_op
 jr FixA2
 
GetPlay2_op:
 ld de,play2_op
 jr FixA2

GetDiffMode2:
 ld de,difficulty_mode
 jr FixA2

GetFirexy2:
 ld de,Firexy
 jr FixA2
 
GetFirexy2P1:
 ld de,Firexy+1
 jr FixA2
 
GetFoldxy2:
 ld de,FirexyOld
 jr FixA2
 
GetFoldxy2P1:
 ld de,FirexyOld+1
 jr FixA2

GetFGoldxy2:
 ld de,FireGxyOld
 jr FixA2
 
GetFGoldxy2P1:
 ld de,FireGxyOld+1
 jr FixA2

GetFireGxyA2:
 ld de,FireGxy
 jr FixA2
 
GetFireGxy2P1:
 ld de,FireGxy+1
 jr FixA2
 
StartGame:
 ROM_CALL(CLEARTEXT)
 ROM_CALL(BUSY_OFF)
 ld a,1
 CALL_(GetPlay1_op)
 CALL_(GetPlay2_op)
 CALL_(GetVegeta)
 CALL_(LoadP1)
 CALL_(GetChar1)
 CALL_(GetP_Op2)
 ldir
 CALL_(GetVegeta)
 CALL_(LoadP2)
 CALL_(GetChar1)
 CALL_(GetP_Op3)
 ldir
 xor a
 ld de,$1000
 CALL_(DispA)

Difficulty:
 CALL_(Show_POp2)
 CALL_(Show_POp3)
 CALL_(InvText)
 CALL_(Show_POp1)
 CALL_(InvText)
Diff_2:
 call GET_KEY
 cp K_RIGHT
 jr z,IncDiff
 cp K_LEFT
 jr z,DecDiff
 cp K_DOWN
 JUMP_Z(Player1)
 cp K_ENTER
 JUMP_Z(Really_Start)
 cp K_UP
 JUMP_Z(Player2)
 jr Diff_2
 
Show_POp2:
 ld de,P_Op2
 CALL_(FixGet)
 ld bc,$0001
 JUMP_(ShowBig)
 
Show_POp3:
 ld de,P_Op3
 CALL_(FixGet)
 ld bc,$0002
 JUMP_(ShowBig)
 
Show_POp1:
 ld de,P_Op1
 CALL_(FixGet)
 ld bc,$0000
 JUMP_(ShowBig)
 
IncDiff:
 CALL_(GetDiffMode)
 cp 2
 JUMP_Z(Difficulty)
 inc a
 JUMP_(Set_Diff)
 
DecDiff:
 CALL_(GetDiffMode)
 or a
 JUMP_Z(Difficulty)
 dec a
Set_Diff:
 ld de,difficulty_mode
 CALL_(FixA2)
 ld de,$1000
 
DispA:
 inc a
 ld l,a
 ld h,0
 xor a
 ld (CURSOR_ROW),de
 ROM_CALL(D_HL_DECI)
 JUMP_(Difficulty)
 
Load_POp2:
 CALL_(GetP_Op2)
 ldir
 
Player1:
 CALL_(Show_POp1)
 CALL_(Show_POp3)
 CALL_(InvText)
 CALL_(Show_POp2)
 CALL_(InvText)
Play1_2:
 call GET_KEY
 cp K_UP
 JUMP_Z(Difficulty)
 cp K_RIGHT
 jr z,IncPlay1
 cp K_LEFT
 jr z,DecPlay1
 cp K_ENTER
 JUMP_Z(Really_Start)
 cp K_DOWN
 JUMP_Z(Player2)
 cp K_LOG
 JUMP_Z(Cart1)
 cp K_SIN
 JUMP_Z(Friz1)
 cp K_TAN
 JUMP_Z(Buu1)
 jr Play1_2

IncPlay1:
 CALL_(GetPlay1_op2)
 cp 8
 jr z,Player1
 inc a
 CALL_(GetPlay1_op)
 cp 8
 jr z,Got1
 jr Play1_1
 
DecPlay1:
 CALL_(GetPlay1_op2)
 cp 1
 JUMP_Z(Player1)
 dec a
 CALL_(GetPlay1_op)
 cp 1
 jr z,Vp1
Play1_1:
 cp 2
 JUMP_Z(Gp1)
 cp 3
 JUMP_Z(G3p1)
 cp 5
 JUMP_Z(Tp1)
 cp 4
 JUMP_Z(Hp1)
 cp 6
 JUMP_Z(Raditz1)
 cp 7
 jr z,GGtp1
 JUMP_(Player1)
 
Got1:
 CALL_(Clear_Char1)
 CALL_(GetGotenks)
 CALL_(LoadP1)
 CALL_(GetGotnk)
 JUMP_(Load_POp2)
 
Vp1:
 CALL_(Clear_Char1)
 CALL_(GetVegeta)
 CALL_(LoadP1)
 CALL_(GetChar1)
 JUMP_(Load_POp2)
 
GGtp1:
 CALL_(Clear_Char1) 
 CALL_(GetGokuGT)
 CALL_(LoadP1)
 CALL_(GetGGtText)
 JUMP_(Load_POp2)

Friz1:
 CALL_(Clear_Char1)
 CALL_(GetFrieza)
 CALL_(LoadP1)
 CALL_(GetCharF)
 JUMP_(Load_POp2)
 
Gp1:
 CALL_(Clear_Char1)
 CALL_(GetKakarot)
 CALL_(LoadP1)
 CALL_(GetChar2)
 JUMP_(Load_POp2)

G3p1:
 CALL_(Clear_Char1)
 CALL_(GetSSJ3_Goku)
 CALL_(LoadP1)
 CALL_(GetChar4)
 JUMP_(Load_POp2)
 
Hp1:
 CALL_(Clear_Char1)
 CALL_(GetGohan)
 CALL_(LoadP1)
 CALL_(GetChar5)
 JUMP_(Load_POp2)

Tp1:
 CALL_(Clear_Char1)
 CALL_(GetTrunks)
 CALL_(LoadP1)
 CALL_(GetChar6)
 JUMP_(Load_POp2)
 
Cart1:
 CALL_(Clear_Char1)
 CALL_(GetCartman)
 CALL_(LoadP1)
 CALL_(GetCart)
 ld bc,12
 JUMP_(Load_POp2)
 
Raditz1:
 CALL_(Clear_Char1)
 CALL_(GetRaditz)
 CALL_(LoadP1)
 CALL_(GetRad)
 JUMP_(Load_POp2)

Buu1:
 CALL_(Clear_Char1)
 CALL_(GetBuu)
 CALL_(LoadP1)
 CALL_(GetMajin)
 JUMP_(Load_POp2)
 
LoadP1:
 ld de,play1+2
 CALL_(FixDE)
 ld bc,56
 ldir
 CALL_(GetClear)
 CALL_(GetP_Op2)
 ld bc,18
 ldir
Clear_Char1:
 xor b
 ld c,$24
 ld de,play1
 CALL_(FixGet)
 JUMP_(PutSprite16)
 
Load_POp3:
 CALL_(GetP_Op3)
 ldir
 
Player2:
 CALL_(Show_POp2)
 CALL_(Show_POp1)
 CALL_(InvText)
 CALL_(Show_POp3)
 CALL_(InvText)
Play2_2:
 call GET_KEY
 cp K_UP
 JUMP_Z(Player1)
 cp K_RIGHT
 jr z,IncPlay2
 cp K_LEFT
 jr z,DecPlay2
 cp K_DOWN
 JUMP_Z(Difficulty)
 cp K_SIN
 JUMP_Z(Friz2)
 cp K_ENTER
 JUMP_Z(Really_Start)
 cp K_LOG
 JUMP_Z(Cart2)
 cp K_TAN
 JUMP_Z(Buu2)
 jr Play2_2
 
IncPlay2:
 CALL_(GetPlay2_op2)
 cp 8
 jr z,Player2
 inc a
 CALL_(GetPlay2_op)
 cp 8
 jr z,Got2
 jr Play2_1
 
DecPlay2:
 CALL_(GetPlay2_op2)
 cp 1
 JUMP_Z(Player2)
 dec a
 CALL_(GetPlay2_op)
 cp 1
 JUMP_Z(Vp2)
Play2_1:
 cp 2
 JUMP_Z(Gp2)
 cp 4
 JUMP_Z(Hp2)
 cp 3
 JUMP_Z(G3p2)
 cp 5
 JUMP_Z(Tp2)
 cp 6
 jr z,GGtp2
 cp 7
 JUMP_Z(Raditz2)
 JUMP_(Player2)
 
Got2:
 CALL_(Clear_Char2)
 CALL_(GetGotenks)
 CALL_(LoadP2)
 CALL_(GetGotnk)
 JUMP_(Load_POp3)
 
GGtp2:
 CALL_(Clear_Char2)
 CALL_(GetGokuGT)
 CALL_(LoadP2)
 CALL_(GetGGtText)
 JUMP_(Load_POp3)
 
Friz2:
 CALL_(Clear_Char2)
 CALL_(GetFrieza)
 CALL_(LoadP2)
 CALL_(GetCharF)
 JUMP_(Load_POp3)
 
Vp2:
 CALL_(Clear_Char2)
 CALL_(GetVegeta)
 CALL_(LoadP2)
 CALL_(GetChar1)
 JUMP_(Load_POp3)
 
Gp2:
 CALL_(Clear_Char2)
 CALL_(GetKakarot)
 CALL_(LoadP2)
 CALL_(GetChar2)
 JUMP_(Load_POp3)

Cart2:
 CALL_(Clear_Char2)
 CALL_(GetCartman)
 CALL_(LoadP2)
 CALL_(GetCart)
 ld bc,12
 JUMP_(Load_POp3)

G3p2:
 CALL_(Clear_Char2)
 CALL_(GetSSJ3_Goku)
 CALL_(LoadP2)
 CALL_(GetChar4)
 JUMP_(Load_POp3)
 
Hp2:
 CALL_(Clear_Char2)
 CALL_(GetGohan)
 CALL_(LoadP2)
 CALL_(GetChar5)
 JUMP_(Load_POp3)

Tp2:
 CALL_(Clear_Char2)
 CALL_(GetTrunks)
 CALL_(LoadP2)
 CALL_(GetChar6)
 JUMP_(Load_POp3)
 
Raditz2:
 CALL_(Clear_Char2)
 CALL_(GetRaditz)
 CALL_(LoadP2)
 CALL_(GetRad)
 JUMP_(Load_POp3)

Buu2:
 CALL_(Clear_Char2)
 CALL_(GetBuu)
 CALL_(LoadP2)
 CALL_(GetMajin)
 JUMP_(Load_POp3)
 
LoadP2:
 ld de,play2+2
 CALL_(FixDE)
 ld bc,56
 ldir
 ld de,play2+2
 CALL_(FixGet)
 ld b,56
 CALL_(Reverse_Sprite)
 ld ix,($8C3C)
 ld de,play2+2
 add ix,de
 ld b,28
 CALL_(Rev16)
 CALL_(GetClear)
 CALL_(GetP_Op3)
 ld bc,18
 ldir
Clear_Char2:
 ld bc,$5024
 CALL_(GetPlay2)
 JUMP_(PutSprite16)
 
Reverse_Sprite:
 ld c,(hl)
 CALL_(FixC2)
 CALL_(FixC2)
 CALL_(FixC2)
 CALL_(FixC2)
 ld (hl),a
 inc hl
 djnz Reverse_Sprite
 ret

FixC2:
 rlc c
 rra
 rlc c
 rra
 ret

Rev16:
 ld d,(ix)
 ld e,(ix+1)
 ld (ix),e
 ld (ix+1),d
 inc ix
 inc ix
 djnz Rev16
 ret
 
Really_Start:
 ROM_CALL(CLEARTEXT)
 CALL_(Black_Band)
 ld a,5
 CALL_(GetVegetaxy)
 CALL_(GetVegetaxyP1)
 CALL_(GetVoldxy)
 CALL_(GetVoldxyP1)
 CALL_(GetKakarotxy2P1)
 CALL_(GetKoldxy2P1)
 ld b,a
 ld c,a
 CALL_(GetPlay1)
 CALL_(PutSprite16)
 ld a,$5F
 CALL_(GetKakarotxy2)
 CALL_(GetKoldxy2)
 ld b,a
 ld c,5
 CALL_(GetPlay2)
 CALL_(PutSprite16)
 xor a
 ld de,IsFireG
 CALL_(FixA2)
 ld de,IsFire
 CALL_(FixA2)
 ld de,Kakarot_counter
 CALL_(FixA2)
 ld a,30
 ld de,VegetaP
 CALL_(FixA2)
 ld a,97
 ld de,KakarotP
 CALL_(FixA2)
 
GameKeyLoop:
 CALL_(GetDiffMode)
 ld b,a
 or a
 jr z,very_hard_mode
diffloop:
 halt
 djnz diffloop
very_hard_mode:
 call GET_KEY
 cp K_PLUS
 CALL_Z(c_up)
 cp K_MINUS
 CALL_Z(c_down)
 ld a,126
 out (1),a
 in a,(1)
 bit 3,a
 push af
 CALL_Z(MoveUP)
 pop af
 bit 2,a
 push af
 CALL_Z(MoveRIGHT)
 pop af
 bit 1,a
 push af
 CALL_Z(MoveLEFT)
 pop af
 bit 0,a
 CALL_Z(MoveDOWN)
 ld a,63
 out (1),a
 in a,(1)
 bit 5,a
 push af
 CALL_Z(Fire)
 pop af
 bit 6,a
 JUMP_Z(EXIT_)
 bit 7,a
 CALL_Z(Pause)
 CALL_(moveFireball)
 
Moves_Kakarot_Randomly:
 CALL_(GetDiffMode)
 ld b,a
 or a
 jr z,very_hard_mode2
diffloop2:
 halt
 djnz diffloop2
very_hard_mode2:
 CALL_(KakarotFIRES)
 ld de,Kakarot_counter
 CALL_(FixA)
 or a
 jr z,new_direction
 CALL_(GetKakarot_D)
 cp 1
 CALL_Z(MoveKakarotLeft)
 CALL_(GetKakarot_D)
 cp 2
 CALL_Z(MoveKakarotRight)
 CALL_(GetKakarot_D)
 cp 3
 CALL_Z(MoveKakarotUp)
 CALL_(GetKakarot_D)
 cp 4
 CALL_Z(MoveKakarotDown)
 ld de,Kakarot_counter
 CALL_(FixGet)
 dec (hl)
 JUMP_(GameKeyLoop)
new_direction:
 ld a,r
 and 3
 inc a
 ld de,Kakarot_direction
 CALL_(FixA2)
 ld a,10
 ld de,Kakarot_counter
 CALL_(FixA2)
 JUMP_(GameKeyLoop)
 
KakarotFIRES:
 CALL_(FireG)
 JUMP_(moveFireballG)
 
Collision_DetectionG:
 CALL_(GetVegetaxy2)
 ld b,a
 CALL_(GetFireGxy)
 sub b
 cp 23
 ret nc
 CALL_(GetVegetaxy2p1)
 ld b,a
 CALL_(GetFireGxyP1)
 sub b
 sub 13
 cp 3
 ret nc
 ld de,VegetaP
 CALL_(FixA)
 ld d,61
 ld e,a
 CALL_(FindPixel)
 cpl
 and (hl)
 ld (hl),a
 inc e
 inc d
 CALL_(FindPixel)
 cpl
 and (hl)
 ld (hl),a
 inc d
 dec e
 CALL_(FindPixel)
 cpl
 and (hl)
 ld (hl),a
 ld de,VegetaP
 CALL_(FixGet)
 dec (hl)
 ld a,(hl)
 or a
 ret nz
 pop bc
 pop bc
 pop bc
 JUMP_(ContinuePrg)
 
Collision_Detection:
 CALL_(GetKakarotxy)
 ld b,a
 CALL_(GetFirexy)
 sub b
 cp 23
 ret nc
 CALL_(GetKakarotxyP1)
 ld b,a
 CALL_(GetFirexyP1)
 add a,16
 sub b
 cp 3
 ret nc
 ld de,KakarotP
 CALL_(FixA)
 ld d,61
 ld e,a
 CALL_(FindPixel)
 cpl
 and (hl)
 ld (hl),a
 dec e
 inc d
 CALL_(FindPixel)
 cpl
 and (hl)
 ld (hl),a
 inc d
 inc e
 CALL_(FindPixel)
 cpl
 and (hl)
 ld (hl),a
 ld de,KakarotP
 CALL_(FixGet)
 inc (hl)
 ld a,(hl)
 cp 128
 ret nz
 pop bc
 pop bc
 pop bc
 JUMP_(Winner)
 
FindPixel:
 ld de,FP_Bits
 CALL_(FixGet)
 ld a,e
 and 7
 add a,l
 ld l,a
 adc a,h
 sub l
 ld h,a
 ld c,(hl)
 ld de,FP_RLD
 CALL_(FixGet)
 ld (hl),d
 ld a,e
 rrca
 rrca   
 rrca
 rld
 or $FC 
 ld l,(hl)
 ld h,a
 ld a,c
 ret

PutSprite16:
 push hl
 ld h,$3F
 ld a,c
 add a,a
 add a,a
 ld l,a
 add hl,hl
 add hl,hl
 ld a,b
 and %00000111
 ld c,a
 inc c
 ld a,b
 rra
 rra
 rra
 and %00011111
 or l
 ld l,a
 pop de
 inc de
 ld a,(de)
 ld b,a
 inc de
 push de
 pop ix
 
DrawLoop:
 push bc
 ld a,(ix)
 inc ix
 ld d,(ix)
 inc ix
 ld e,0
 and a
 rl d
 rla
 ld b,c

RotLoop1:
 rra
 rr d
 rr e
 djnz RotLoop1
 xor (hl)
 ld (hl),a
 ld a,d
 inc hl
 xor (hl)
 ld (hl),a
 ld a,e
 inc hl
 xor (hl)
 ld (hl),a
 ld de,14
 add hl,de
 jr nc,NoWrap
 ld de,$FC00
 add hl,de

NoWrap:
 pop bc
 djnz DrawLoop
 ret
 
MoveKakarotUp:
 CALL_(GetKakarotxy)
 ld b,a
 CALL_(GetKakarotxyP1)
 ld c,a
 dec c
 ld a,c
 cp 255
 ret z
 ld a,c
 CALL_(GetKakarotxy2P1)
 ld a,b
 CALL_(GetKakarotxy2)
 JUMP_(moveKakarot)
 
MoveKakarotDown:
 CALL_(GetKakarotxy)
 ld b,a
 CALL_(GetKakarotxyP1)
 ld c,a
 inc c
 ld a,c
 cp 31
 ret nc
 ld a,c
 CALL_(GetKakarotxy2P1)
 ld a,b
 CALL_(GetKakarotxy2)
 jr moveKakarot
 
MoveKakarotRight:
 CALL_(GetKakarotxyP1)
 ld c,a
 CALL_(GetKakarotxy)
 ld b,a
 inc b
 ld a,b
 cp $70
 ret z
 ld a,b
 CALL_(GetKakarotxy2)
 ld a,c
 CALL_(GetKakarotxy2P1)
 jr moveKakarot
 
MoveKakarotLeft:
 CALL_(GetKakarotxyP1)
 ld c,a
 CALL_(GetKakarotxy)
 ld b,a
 dec b
 ld a,b
 cp $50
 ret z
 ld a,b
 CALL_(GetKakarotxy2)
 ld a,c
 CALL_(GetKakarotxy2P1)
 
moveKakarot:
 ld de,KakarotxyOld
 CALL_(FixA)
 ld b,a
 ld de,KakarotxyOld+1
 CALL_(FixA)
 ld c,a
 CALL_(GetPlay2)
 CALL_(PutSprite16)
 CALL_(GetKakarotxyP1)
 ld c,a
 CALL_(GetKakarotxy)
 ld b,a
 ld a,c
 CALL_(GetKoldxy2P1)
 ld a,b
 CALL_(GetKoldxy2)
 CALL_(GetPlay2)
 JUMP_(PutSprite16)
 
MoveRIGHT:
 CALL_(GetVegetaxy2p1)
 ld c,a
 CALL_(GetVegetaxy2)
 ld b,a
 inc b
 ld a,b
 cp $30
 ret z
 ld a,b
 CALL_(GetVegetaxy)
 ld a,c
 CALL_(GetVegetaxyP1)
 JUMP_(moveVegeta)
 
MoveUP:
 CALL_(GetVegetaxy2)
 ld b,a
 CALL_(GetVegetaxy2p1)
 ld c,a
 dec c
 ld a,c
 cp 255
 ret z
 ld a,c
 CALL_(GetVegetaxyP1)
 ld a,b
 CALL_(GetVegetaxy)
 jr moveVegeta
 
MoveDOWN:
 CALL_(GetVegetaxy2)
 ld b,a
 CALL_(GetVegetaxy2p1)
 ld c,a
 inc c
 ld a,c
 cp 31
 ret nc
 ld a,c
 CALL_(GetVegetaxyP1)
 ld a,b
 CALL_(GetVegetaxy)
 jr moveVegeta
 
MoveLEFT:
 CALL_(GetVegetaxy2p1)
 ld c,a
 CALL_(GetVegetaxy2)
 ld b,a
 dec b
 ld a,b
 or a
 ret z
 ld a,b
 CALL_(GetVegetaxy)
 ld a,c
 CALL_(GetVegetaxyP1)
 
moveVegeta:
 ld de,VegetaxyOld
 CALL_(FixA)
 ld b,a
 ld de,VegetaxyOld+1
 CALL_(FixA)
 ld c,a
 CALL_(GetPlay1)
 CALL_(PutSprite16)
 CALL_(GetVegetaxy2p1)
 ld c,a
 CALL_(GetVegetaxy2)
 ld b,a
 ld a,c
 CALL_(GetVoldxyP1)
 ld a,b
 CALL_(GetVoldxy)
 CALL_(GetPlay1)
 JUMP_(PutSprite16)
 
Fire:
 CALL_(GetIsFire)
 xor a
 cp (hl)
 ret nz
 ld (hl),1
 CALL_(GetVegetaxy2p1)
 add a,11
 ld c,a
 CALL_(GetVegetaxy2)
 add a,8
 ld b,a
 ld a,b
 CALL_(GetFirexy2)
 ld a,b
 CALL_(GetFoldxy2)
 ld a,c
 CALL_(GetFirexy2P1)
 ld a,c
 CALL_(GetFoldxy2P1)
 CALL_(GetFball)
 JUMP_(PutSprite16)
 
FireG:
 CALL_(GetIsFireG)
 xor a
 cp (hl)
 ret nz
 ld (hl),1
 CALL_(GetKakarotxyP1)
 add a,11
 ld c,a
 CALL_(GetKakarotxy)
 sub 8
 ld b,a
 ld a,b
 CALL_(GetFireGxyA2)
 ld a,b
 CALL_(GetFGoldxy2)
 ld a,c
 CALL_(GetFireGxy2P1)
 ld a,c
 CALL_(GetFGoldxy2P1)
 CALL_(GetFball2)
 JUMP_(PutSprite16)
 
moveFireball:
 CALL_(GetIsFire)
 xor a
 cp (hl)
 ret z
 CALL_(GetFirexy)
 ld b,a
 CALL_(GetFirexyP1)
 ld c,a
 inc b
 inc b
 ld a,111
 cp b
 JUMP_C(fire_hit_wall)
 ld a,b
 CALL_(GetFirexy2)
 ld a,c
 CALL_(GetFirexy2P1)
 push bc
 CALL_(Collision_Detection)
 CALL_(GetFoldxy)
 ld b,a
 CALL_(GetFoldxyP1)
 ld c,a
 CALL_(GetFball)
 push hl
 CALL_(PutSprite16)
 pop hl
 pop bc
 ld a,b
 CALL_(GetFoldxy2)
 ld a,c
 CALL_(GetFoldxy2P1)
 JUMP_(PutSprite16)
 
moveFireballG:
 CALL_(GetIsFireG)
 xor a
 cp (hl)
 ret z
 CALL_(GetFireGxy)
 ld b,a
 CALL_(GetFireGxyP1)
 ld c,a
 dec b
 dec b
 ld a,1
 cp b
 JUMP_NC(fire_hit_wallG)
 ld a,b
 CALL_(GetFireGxyA2)
 ld a,c
 CALL_(GetFireGxy2P1)
 push bc
 CALL_(Collision_DetectionG)
 CALL_(GetFGoldxy)
 ld b,a
 CALL_(GetFGoldxyP1)
 ld c,a
 CALL_(GetFball2)
 push hl
 CALL_(PutSprite16)
 pop hl
 pop bc
 ld a,b
 CALL_(GetFGoldxy2)
 ld a,c
 CALL_(GetFGoldxy2P1)
 JUMP_(PutSprite16)
  
fire_hit_wall:
 CALL_(GetFoldxy)
 ld b,a
 CALL_(GetFoldxyP1)
 ld c,a
 CALL_(GetFball)
 CALL_(PutSprite16)
 xor a
 ld de,IsFire
 CALL_(FixA2)
 ret

fire_hit_wallG:
 CALL_(GetFGoldxy)
 ld b,a
 CALL_(GetFGoldxyP1)
 ld c,a
 CALL_(GetFball2)
 CALL_(PutSprite16)
 xor a
 ld de,IsFire
 CALL_(FixA2)
 ret
 
Winner:
 ROM_CALL(CLEARTEXT)
 ld hl,($8C3C)
 ld de,WinPic
 add hl,de
 CALL_(SetUp)
 JUMP_(ContinuePrg)
 
EXIT_:
 ld a,$3C
 out (0),a
 ROM_CALL(CLEARTEXT)
 ROM_CALL(SCROLL_UP)
 res 3,(iy+35)
 res 1,(iy+13)
 ld a,3
 ld ($8C40),a
 JUMP_($8CC2) ; Whatever exits to shell/os!!!

#include "data128.asm"
 
.end